## inn2 2.7.2

=== debian/changelog ===
inn2 (2.7.2-1) unstable; urgency=medium

  * New upstream release.

 -- Marco d'Itri <md@linux.it>  Sun, 23 Jun 2024 16:53:00 +0200

inn2 (2.7.2~20240519-1) unstable; urgency=medium

  * New upstream snapshot of the stable branch.

 -- Marco d'Itri <md@linux.it>  Fri, 31 May 2024 03:57:34 +0200

inn2 (2.7.2~20240325-3) unstable; urgency=medium

  * Keep improving the autopkgtest.

 -- Marco d'Itri <md@linux.it>  Tue, 02 Apr 2024 01:17:02 +0200

inn2 (2.7.2~20240325-2) unstable; urgency=medium

  * inn2.postinst: hardcode the pathdb default, to support installation
    on the Debian CI infrastructure.

 -- Marco d'Itri <md@linux.it>  Mon, 01 Apr 2024 19:23:25 +0200

inn2 (2.7.2~20240325-1) unstable; urgency=medium

  * New upstream snapshot of the stable branch.
  * Try again running the autopkgtest.

 -- Marco d'Itri <md@linux.it>  Mon, 01 Apr 2024 12:29:55 +0200
