=== debian/changelog ===
inn2 (2.7.3~20241006-1) unstable; urgency=medium

  * New upstream snapshot of the stable branch.

 -- Marco d'Itri <md@linux.it>  Mon, 07 Oct 2024 02:12:05 +0200
