=== debian/control ===
--- 
+++ 
@@ -3,7 +3,9 @@
 Priority: optional
 Maintainer: Marco d'Itri <md@linux.it>
 Build-Depends: debhelper-compat (= 13), bison, flex, groff-base,
- libperl-dev, python3-dev, libdb-dev, libkrb5-dev, libpam0g-dev, libsasl2-dev,
+ libperl-dev,
+ python3-dev:native, libpython3-dev,
+ libdb-dev, libkrb5-dev, libpam0g-dev, libsasl2-dev,
  libsystemd-dev, pkgconf,
  libcanlock-dev, libsqlite3-dev, libssl-dev, zlib1g-dev,
 Standards-Version: 4.7.0.0
